package data.scripts.hullmods;

import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.CombatEngineAPI;
import com.fs.starfarer.api.combat.FighterWingAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;
import java.util.HashMap;
import java.util.Map;

public class VayraWarhawkModular extends BaseHullMod {

    private static final Map<HullSize, Integer> REFITS = new HashMap<>();
    static {
        REFITS.put(HullSize.FIGHTER, 0);
        REFITS.put(HullSize.FRIGATE, 2);
        REFITS.put(HullSize.DESTROYER, 3);
        REFITS.put(HullSize.CRUISER, 4);
        REFITS.put(HullSize.CAPITAL_SHIP, 5);
    }
    
    private static final Map<FighterWingAPI, Float> BASE_REFIT = new HashMap<>();

    @Override
    public void advanceInCombat(ShipAPI ship, float amount) {
        CombatEngineAPI engine = Global.getCombatEngine();
        if (ship == null || engine == null || engine.isPaused()) {
            return;
        }

        for (FighterWingAPI wing : ship.getAllWings()) {
            if (!BASE_REFIT.containsKey(wing)) {
                BASE_REFIT.put(wing, wing.getSpec().getRefitTime());
            }
            
            if (wing.getSource().getNumLost() < REFITS.get(ship.getHullSize())) {
                wing.getSpec().setRefitTime(0.666f);
            } else {
                wing.getSpec().setRefitTime(BASE_REFIT.get(wing));
            }
        }
    }

    @Override
    public String getDescriptionParam(int index, HullSize hullSize) {
        if (index == 0) {
            return "universal";
        }
        if (index == 1) {
            return "" + REFITS.get(hullSize);
        }
        if (index == 2) {
            return "instantaneously";
        }
        return null;
    }

}
